local ip = arg[1]
local cpus = arg[2]
local global_file = arg[3]
local teach_point = arg[4]  
local utils_api_file = "/dobot/bin/lua/utils_api.lua"

-- define local var
local cpu_table = {}
local cpu_table_count = 0 
local cpu_table_idx = {}
local cpu_route = 0;
local cpu_start = false

--calic cpu file
string.gsub(cpus, '[^,]+', function(w) table.insert(cpu_table, w) end )
for k,v in pairs(cpu_table) do  
    cpu_table_count = cpu_table_count + 1  
end  


--define cpu call
function cpu_callback( file )
	--dofile(file)
	local status, err = pcall(dofile, file)
	if status then
			
	else
		print("ERROR:", err)
		EventLog("ERROR:", err)
		print("run script failed!");
		EventLog("run script failed!")
		Sleep(300)
		os.exit()	
	end
end
function cpu_callbackDefaultCpu( file )
	require("mobdebug").start(ip)
	--dofile(file)
	local status, err = pcall(dofile, file)
	if status then
			
	else
		print("ERROR:", err)
		EventLog("ERROR:", err)
		print("run script failed!");
		EventLog("run script failed!")
		Sleep(300)
		os.exit()
	end
end


local function baseApiPreInit()
	Sleep=dobot.Sleep
	EventLog=dobot.EventLog
	print=dobot.print
end

local function initTeachGlobalApiUserApiFile()


	
	-- load teach_point
	if teach_point ~= "" then
		-- print("[lua] Load teach point file", teach_point)
		local status, err = pcall(dofile, teach_point)
		if status then
			-- print("[lua] Load teach point file", teach_point)
		else
			print("ERROR:", err)
			EventLog("ERROR:", err)
			print("run script failed!");
			EventLog("run script failed!")
			Sleep(300)
			os.exit()
		end
	end

	--load global file
	if global_file ~= "" then
		-- print("[lua] Load global file", global_file)
		local status, err = pcall(dofile, global_file)
		if status then
			-- print("[lua] Load global file", global_file)
		else
			print("ERROR:", err)
			EventLog("ERROR:", err)
			print("run script failed!");
			EventLog("run script failed!")
			Sleep(300)
			os.exit()
		end
	end

	dofile(utils_api_file)
end


local function initSystem()
	dobot = require("libdataSvrPlugin")
	dobot.init(0)
	baseApiPreInit()
	initTeachGlobalApiUserApiFile()
	dofile("/dobot/bin/lua/dobot_api.lua")
	dofile("/dobot/bin/lua/pallet_api.lua")

	--start cpu
	cpu_route = cpu_table_count
	Sleep(300)
	while( cpu_route > 0 )
	do
		-- start cpu
		if cpu_route == 1 then
			cpu_callbackDefaultCpu(cpu_table[cpu_route])
		else
			cpu_table_idx[cpu_route] = systhread.create(cpu_callback, cpu_table[cpu_route])
		end
		cpu_route = cpu_route - 1
	end
end

initSystem()

cpu_route = cpu_table_count
while( cpu_route > 1 )
do
	cpu_table_idx[cpu_route]:wait()
	cpu_route = cpu_route - 1
end

--end exec
Sync()
print("run script finished!");
EventLog("run script finished!")
Sleep(300)
